// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login HTTP server types
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package server

import (
	login "gitlab.eclipse.org/eclipse/xfsc/tsa/login/gen/login"
	goa "goa.design/goa/v3/pkg"
)

// LoginRequestBody is the type of the "login" service "Login" endpoint HTTP
// request body.
type LoginRequestBody struct {
	Email *string `form:"email,omitempty" json:"email,omitempty" xml:"email,omitempty"`
}

// LoginWithVCRequestBody is the type of the "login" service "LoginWithVC"
// endpoint HTTP request body.
type LoginWithVCRequestBody struct {
	ProofRecordID *string `form:"proofRecordId,omitempty" json:"proofRecordId,omitempty" xml:"proofRecordId,omitempty"`
}

// LoginResponseBody is the type of the "login" service "Login" endpoint HTTP
// response body.
type LoginResponseBody struct {
	// Status message response.
	Message string `form:"message" json:"message" xml:"message"`
}

// LoginInvitationResponseBody is the type of the "login" service
// "LoginInvitation" endpoint HTTP response body.
type LoginInvitationResponseBody struct {
	// Identifier of the proof invitation request.
	ProofRecordID string `form:"proofRecordId" json:"proofRecordId" xml:"proofRecordId"`
	// Link containing the invitation proof request which the PCM can scan to login.
	PresentationMessage string `form:"presentationMessage" json:"presentationMessage" xml:"presentationMessage"`
	// Shortened URL link which the PCM can scan to login.
	PresentationMessageShort string `form:"presentationMessageShort" json:"presentationMessageShort" xml:"presentationMessageShort"`
	// Timestamp for when the invitation was created.
	CreatedDate string `form:"createdDate" json:"createdDate" xml:"createdDate"`
}

// LoginWithVCResponseBody is the type of the "login" service "LoginWithVC"
// endpoint HTTP response body.
type LoginWithVCResponseBody struct {
	// Token in JWT format after successful login.
	Token any `form:"token" json:"token" xml:"token"`
}

// KeysResponseBody is the type of the "login" service "Keys" endpoint HTTP
// response body.
type KeysResponseBody struct {
	// List of public keys.
	Keys []any `form:"keys" json:"keys" xml:"keys"`
}

// NewLoginResponseBody builds the HTTP response body from the result of the
// "Login" endpoint of the "login" service.
func NewLoginResponseBody(res *login.LoginResult) *LoginResponseBody {
	body := &LoginResponseBody{
		Message: res.Message,
	}
	return body
}

// NewLoginInvitationResponseBody builds the HTTP response body from the result
// of the "LoginInvitation" endpoint of the "login" service.
func NewLoginInvitationResponseBody(res *login.LoginInvitationResult) *LoginInvitationResponseBody {
	body := &LoginInvitationResponseBody{
		ProofRecordID:            res.ProofRecordID,
		PresentationMessage:      res.PresentationMessage,
		PresentationMessageShort: res.PresentationMessageShort,
		CreatedDate:              res.CreatedDate,
	}
	return body
}

// NewLoginWithVCResponseBody builds the HTTP response body from the result of
// the "LoginWithVC" endpoint of the "login" service.
func NewLoginWithVCResponseBody(res *login.LoginVCResult) *LoginWithVCResponseBody {
	body := &LoginWithVCResponseBody{
		Token: res.Token,
	}
	return body
}

// NewKeysResponseBody builds the HTTP response body from the result of the
// "Keys" endpoint of the "login" service.
func NewKeysResponseBody(res *login.KeysResult) *KeysResponseBody {
	body := &KeysResponseBody{}
	if res.Keys != nil {
		body.Keys = make([]any, len(res.Keys))
		for i, val := range res.Keys {
			body.Keys[i] = val
		}
	} else {
		body.Keys = []any{}
	}
	return body
}

// NewLoginRequest builds a login service Login endpoint payload.
func NewLoginRequest(body *LoginRequestBody) *login.LoginRequest {
	v := &login.LoginRequest{
		Email: *body.Email,
	}

	return v
}

// NewLoginWithVCLoginVCRequest builds a login service LoginWithVC endpoint
// payload.
func NewLoginWithVCLoginVCRequest(body *LoginWithVCRequestBody) *login.LoginVCRequest {
	v := &login.LoginVCRequest{
		ProofRecordID: *body.ProofRecordID,
	}

	return v
}

// ValidateLoginRequestBody runs the validations defined on LoginRequestBody
func ValidateLoginRequestBody(body *LoginRequestBody) (err error) {
	if body.Email == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("email", "body"))
	}
	if body.Email != nil {
		err = goa.MergeErrors(err, goa.ValidateFormat("body.email", *body.Email, goa.FormatEmail))
	}
	return
}

// ValidateLoginWithVCRequestBody runs the validations defined on
// LoginWithVCRequestBody
func ValidateLoginWithVCRequestBody(body *LoginWithVCRequestBody) (err error) {
	if body.ProofRecordID == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("proofRecordId", "body"))
	}
	return
}
